variables:
  WM_APPSEC_PYTHON_IMAGE: "python3-build-bullseye:0.0.1-20230528"

# ci templates
include:
  - project: 'repos/security/gitlab-ci-security-templates'
    ref: main
    file: '/python-bandit/python-bandit-ci.yml'
  - project: 'repos/ci-tools/commit-message-validator'
    ref: v2.0.0
    file: '/templates/lint-merge-request.yml'

stages:
  - test

linting-and-unit-tests:
  image: docker-registry.wikimedia.org/${WM_APPSEC_PYTHON_IMAGE}
  stage: test 
  allow_failure: false
 
  cache:
    paths:
      - .cache/pip
      - venv/

  before_script:
    - pip install poetry
    - poetry install
    - source `poetry env info --path`/bin/activate

  script:
    - black --check .
    - flake8 .
    - pytest -v

  rules:
    - when: always
